// CopyTree.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "CopyTree.h"
#include "WordFinder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

//using namespace std;
#include "DTree.h"
#include <conio.h>

class CCopyTree : public CDTreeBehaviour {
  CFile*    pFile;
  CArchive* pAr;
  char      Count;
  char      PathLen;
public:
  CCopyTree() : pAr(0), pFile(0) {
    char Path[_MAX_PATH];
    PathLen=(char)GetCurrentDirectory(sizeof Path, Path);
    try {
      pFile=new CFile;
      if(pFile->Open("CopyTree.bat",CFile::modeCreate|CFile::modeWrite|CFile::shareDenyNone)) {
        pAr=new CArchive(pFile, CArchive::store);
        puts("This will create a batch file called CopyTree.bat which you can edit\r\nor just run to recreate the directory structure in this folder.\r\nNo files are created.\r\n");
        CDTree(Path, *this);
        puts("CopyTree.bat created.");
      }else puts("CopyTree.bat couldn't be created.");
    }catch(...) {puts("Out of disk space writing CopyTree.bat");}
    getch();
  }

  virtual ~CCopyTree() {
    delete pAr;
    delete pFile;
  }

  CString Capitalise(CString S) {
    S.MakeLower();
    char* ptr=S.GetBuffer(0);
    char c;
    if(c=*ptr) *ptr=c&~0x20;
    S.ReleaseBuffer();
    return S;
  }

  void OnFile(CDTreeBase& DTree) {}
  void OnDIR (CDTreeBase& DTree) {
    CString Path(DTree.GetPath().Mid(PathLen));
    if(!Path.IsEmpty()) Path+='\\';
    pAr->WriteString("MD \""+(DTree.GetPath().GetLength()<=PathLen ? DTree.GetPath().Mid(PathLen) : DTree.GetPath().Mid(PathLen+1)+'\\')+Capitalise(DTree.GetName())+"\"\r\n");
    char* Tick=".o*O";
    putch(Tick[(++Count)&3]);
    putch('\r');
  }
  void OnUp  (CDTreeBase& DTree) {}
};

int __cdecl _tmain(int argc, TCHAR* argv[], TCHAR* envp[]) {
	if(!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0)) return 1; // initialize MFC
  CCopyTree();
	return 0;
}

